﻿Imports System.Collections.ObjectModel
Imports WPF_Flex_PagingVB.PeopleServiceReference

Class MainWindow

    Private _startRow As Integer
    Private _pageSize As Integer = 15
    Private _maxRecord As Integer = 100
    Private _people As ObservableCollection(Of PeopleClass)

    Private Sub MainWindow_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        _startRow = 0
        _people = New ObservableCollection(Of PeopleClass)()
        GetData(_startRow, _pageSize)
        peopleDataGrid.ItemsSource = _people
        peopleDataGrid.VerticalAlignment = System.Windows.VerticalAlignment.Top
        AddHandler peopleDataGrid.ScrollPositionChanged, AddressOf peopleDataGrid_ScrollPositionChanged
    End Sub

    Sub peopleDataGrid_ScrollPositionChanged(sender As Object, e As EventArgs)
        If Me._people.Count >= _maxRecord Then
            Return
        End If
        If (Me.peopleDataGrid.ViewRange.Row2).Equals(Me._people.Count - 1) Then
            If (_startRow + _pageSize) < _maxRecord Then
                GetData(_startRow, _startRow + _pageSize)
            Else
                GetData(_startRow, _startRow + (_maxRecord - _startRow))
            End If
        End If
    End Sub
    Private Sub GetData(startRow As Integer, endRow As Integer)
        Dim proxy As New PeopleServiceClient()
        Dim peopleList = proxy.GetData(startRow, endRow)
        _startRow += _pageSize
        For Each person As PeopleClass In peopleList
            _people.Add(person)
        Next
    End Sub
End Class
